<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Poluzbrajalo</title>
</head>

<body>

<canvas id="myCanvas1" width="500" height="500" oncontextmenu="return false;"></canvas>

<canvas id="myCanvas2" width="900" height="500" oncontextmenu="return false;"></canvas>

<script>

function signalModel(v) {
  this.v = v;
  this.listeners = [];
  this.getValue = function() { return this.v; }
  this.setValue = function(v) { if(this.v!=v) {this.v = v; this.fireListeners();} }
  this.fireListeners = function() { 
     for(var i = 0; i < this.listeners.length; i++) {
        this.listeners[i].signalChanged();
     }
  }
}

function additionState(n) {
  function mkarray(n) {
    var arr = [];
    for(var i = 0; i < n; i++) { arr.push(new signalModel(0)); }
    return arr;
  }
  this.a = mkarray(n);
  this.b = mkarray(n);
  this.c = mkarray(n+1);
  this.r = mkarray(n);
  this.hots = [];
}

function adder(canvasName,state,index,base,full) {
  var canvas = document.getElementById(canvasName);
  var context = canvas.getContext("2d");

  this.canvas = canvas;
  this.context = context;
  this.offsetX = 0;
  this.offsetY = 20;
  this.base = base;
  this.showCarryLeft = true;
  this.state = state;
  this.index = index;
  this.full = full;
  this.cinState = 0;  // 0: ne prikazuj, 1: prikaži lijevo, 2: prikaži iznad signala, 3: prikaži klikabilno
  this.showABLabels = true;
  this.measures = {
    horizKonektorDo: 30,
    horizKonektorIzmedu: 50,
    prijenosDuljina: 30
  };

  function hot(x,y,w,h,adder,arr,onlyInvert) {
    this.x = x; this.y = y; this.w = w; this.h = h; this.adder=adder; this.arr=arr; this.onlyInvert=onlyInvert;
    this.contains = function(mx,my) {
      return mx>=this.x && mx<=this.x+this.w && my>=this.y && my<=this.y+this.h;
    }
  }

  this.getSymbolWidth = function() {return 2*this.measures.horizKonektorDo + this.measures.horizKonektorIzmedu;}
  this.getWidth = function() {return (this.full?2:1)*this.measures.prijenosDuljina + this.getSymbolWidth();}

  this.calcResult = function() {
     var sum = this.state.a[index].getValue()+this.state.b[index].getValue();
     if(this.full) sum += this.state.c[index].getValue();
     this.state.r[index].setValue(sum%this.base);
     this.state.c[index+1].setValue(~~(sum/this.base));
  }

  this.signalChanged = function() {
    this.calcResult();
  }

  this.state.a[index].listeners.push(this);
  this.state.b[index].listeners.push(this);
  this.state.c[index].listeners.push(this);

  this.draw = function() {
     var r = this.state.r[index].getValue();
     var c = this.state.c[index+1].getValue();

     var plocica = 24;
     var plocicaDoTijela = 20;
     var horizKonektorDo = this.measures.horizKonektorDo;
     var horizKonektorIzmedu = this.measures.horizKonektorIzmedu;
     var sirina = this.getSymbolWidth();
     var visina = sirina;
     var prijenosDuljina = this.measures.prijenosDuljina;
     var fontSpec = "20px Georgia";
     var fontSpec2 = "14px Georgia";
     var fontSpec3 = "32px Georgia";

     this.context.lineWidth = 1;
     this.context.fillStyle = "white";
     this.context.strokeStyle = "black";

     this.context.beginPath();
     this.context.rect(this.offsetX+prijenosDuljina, this.offsetY+plocica+plocicaDoTijela,sirina,visina);
     this.context.fill();
     this.context.stroke();

     this.context.fillStyle = "#aaaaaa";
     this.context.strokeStyle = "black";
     this.context.beginPath();
     this.context.rect(this.offsetX+prijenosDuljina+horizKonektorDo-plocica/2, this.offsetY,plocica,plocica);
     this.state.hots.push(new hot(this.offsetX+prijenosDuljina+horizKonektorDo-plocica/2, this.offsetY,plocica,plocica,this,this.state.a,false));
     this.context.fill();
     this.context.stroke();
     this.context.textAlign="center";
     this.context.font=fontSpec;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "bottom";
     this.context.fillText(""+this.state.a[index].getValue(),this.offsetX+prijenosDuljina+horizKonektorDo,this.offsetY+plocica-2);
     this.context.textBaseline = "alphabetic";
     this.context.textAlign="center";
     this.context.font=fontSpec2;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "top";
     this.context.fillText("a",this.offsetX+prijenosDuljina+horizKonektorDo,this.offsetY+plocica+plocicaDoTijela+2);
     this.context.textBaseline = "alphabetic";
     this.context.beginPath();
     this.context.moveTo(this.offsetX+prijenosDuljina+horizKonektorDo, this.offsetY+plocica);
     this.context.lineTo(this.offsetX+prijenosDuljina+horizKonektorDo, this.offsetY+plocica+plocicaDoTijela);
     this.context.stroke();
     if(this.showABLabels) {
       this.context.textAlign="center";
       this.context.font=fontSpec2;
       this.context.fillStyle = "#000000";
       this.context.textBaseline = "bottom";
       this.context.fillText("a"+index,this.offsetX+prijenosDuljina+horizKonektorDo,this.offsetY-4);
       this.context.textBaseline = "alphabetic";
     }

     this.context.fillStyle = "#aaaaaa";
     this.context.strokeStyle = "black";
     this.context.beginPath();
     this.context.rect(this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu-plocica/2, this.offsetY,plocica,plocica);
     this.state.hots.push(new hot(this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu-plocica/2, this.offsetY,plocica,plocica,this,this.state.b,false));
     this.context.fill();
     this.context.stroke();
     this.context.textAlign="center";
     this.context.font=fontSpec;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "bottom";
     this.context.fillText(""+this.state.b[index].getValue(),this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu,this.offsetY+plocica-2);
     this.context.textBaseline = "alphabetic";
     this.context.textAlign="center";
     this.context.font=fontSpec2;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "top";
     this.context.fillText("b",this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu,this.offsetY+plocica+plocicaDoTijela+2);
     this.context.textBaseline = "alphabetic";
     this.context.beginPath();
     this.context.moveTo(this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu, this.offsetY+plocica);
     this.context.lineTo(this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu, this.offsetY+plocica+plocicaDoTijela);
     this.context.stroke();
     if(this.showABLabels) {
       this.context.textAlign="center";
       this.context.font=fontSpec2;
       this.context.fillStyle = "#000000";
       this.context.textBaseline = "bottom";
       this.context.fillText("b"+index,this.offsetX+prijenosDuljina+horizKonektorDo+horizKonektorIzmedu,this.offsetY-4);
       this.context.textBaseline = "alphabetic";
     }

     this.context.beginPath();
     this.context.moveTo(this.offsetX, this.offsetY+plocica+plocicaDoTijela+visina/2);
     this.context.lineTo(this.offsetX+prijenosDuljina, this.offsetY+plocica+plocicaDoTijela+visina/2);
     this.context.stroke();
     this.context.textAlign="right";
     this.context.font=fontSpec;
     this.context.fillStyle = "#000000";
     if(this.showCarryLeft) {
       this.context.textBaseline = "middle";
       this.context.fillText(""+c,this.offsetX,this.offsetY+plocica+plocicaDoTijela+visina/2);
       this.context.textBaseline = "alphabetic";
     } else {
       this.context.textBaseline = "bottom";
       this.context.fillText(""+c,this.offsetX+prijenosDuljina*2/3,this.offsetY+plocica+plocicaDoTijela+visina/2);
       this.context.textBaseline = "alphabetic";
     }

     if(this.full) {
       this.context.beginPath();
       this.context.moveTo(this.offsetX+prijenosDuljina+sirina, this.offsetY+plocica+plocicaDoTijela+visina/2);
       this.context.lineTo(this.offsetX+2*prijenosDuljina+sirina, this.offsetY+plocica+plocicaDoTijela+visina/2);
       this.context.stroke();
       if(this.cinState==1 || this.cinState==2) {
         var ci = this.state.c[index].getValue();
         this.context.textAlign="left";
         this.context.font=fontSpec;
         this.context.fillStyle = "#000000";
         if(this.cinState==1) {
           this.context.textBaseline = "middle";
           this.context.fillText(""+ci,this.offsetX+2*prijenosDuljina+sirina,this.offsetY+plocica+plocicaDoTijela+visina/2);
           this.context.textBaseline = "alphabetic";
         } else {
           this.context.textBaseline = "bottom";
           this.context.fillText(""+ci,this.offsetX+prijenosDuljina*(1+1/3)+sirina,this.offsetY+plocica+plocicaDoTijela+visina/2);
           this.context.textBaseline = "alphabetic";
         }
       } else if(this.cinState==3) {
         this.context.fillStyle = "#aaaaaa";
         this.context.strokeStyle = "black";
         this.context.beginPath();
         this.context.rect(this.offsetX+2*prijenosDuljina+sirina, this.offsetY+plocica+plocicaDoTijela+visina/2-plocica/2,plocica,plocica);
         this.state.hots.push(new hot(this.offsetX+2*prijenosDuljina+sirina, this.offsetY+plocica+plocicaDoTijela+visina/2-plocica/2,plocica,plocica,this,this.state.c,true));
         this.context.fill();
         this.context.stroke();
         this.context.textAlign="center";
         this.context.font=fontSpec;
         this.context.fillStyle = "#000000";
         this.context.textBaseline = "middle";
         this.context.fillText(""+this.state.c[index].getValue(),this.offsetX+2*prijenosDuljina+sirina+plocica/2,this.offsetY+plocica+plocicaDoTijela+visina/2);
         this.context.textBaseline = "alphabetic";
       }
     }

     this.context.beginPath();
     this.context.moveTo(this.offsetX+prijenosDuljina+sirina/2, this.offsetY+plocica+plocicaDoTijela+visina);
     this.context.lineTo(this.offsetX+prijenosDuljina+sirina/2, this.offsetY+plocica+plocicaDoTijela+visina+prijenosDuljina);
     this.context.stroke();
     this.context.textAlign="center";
     this.context.font=fontSpec;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "top";
     this.context.fillText(""+r,this.offsetX+prijenosDuljina+sirina/2, this.offsetY+plocica+plocicaDoTijela+visina+prijenosDuljina);
     this.context.textBaseline = "alphabetic";

     this.context.textAlign="center";
     this.context.font=fontSpec2;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "bottom";
     this.context.fillText("r",this.offsetX+prijenosDuljina+sirina/2,this.offsetY+plocica+plocicaDoTijela+visina-2);
     this.context.textBaseline = "alphabetic";

     this.context.textAlign="left";
     this.context.font=fontSpec2;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "middle";
     this.context.fillText("cout",this.offsetX+prijenosDuljina+2,this.offsetY+plocica+plocicaDoTijela+visina/2);
     this.context.textBaseline = "alphabetic";

     if(this.full) {
       this.context.textAlign="right";
       this.context.font=fontSpec2;
       this.context.fillStyle = "#000000";
       this.context.textBaseline = "middle";
       this.context.fillText("cin",this.offsetX+prijenosDuljina+sirina-2,this.offsetY+plocica+plocicaDoTijela+visina/2);
       this.context.textBaseline = "alphabetic";
     }

     this.context.textAlign="center";
     this.context.font=fontSpec3;
     this.context.fillStyle = "#000000";
     this.context.textBaseline = "middle";
     this.context.fillText(this.full?"FA":"HA",this.offsetX+prijenosDuljina+sirina/2,this.offsetY+plocica+plocicaDoTijela+visina/2);
     this.context.textBaseline = "alphabetic";
  }

  this.calcResult();
}

function scene(canvasName, model, state) {
    var canvas = document.getElementById(canvasName);
    var context = canvas.getContext("2d");
    this.canvas = canvas;
    this.context = context;
    this.model = model;
    this.state = state;
    this.drawAll = function() {
      this.repaintRequested = false;
      this.state.hots.length = 0;
      this.context.lineWidth = 1;
      this.context.fillStyle = "white";
      this.context.strokeStyle = "black";
      this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
      for(var i = 0; i < this.model.length; i++) {
         this.model[i].draw();
      }
    }

    this.repaintRequested = false;

    this.signalChanged = function() {
      if(this.repaintRequested) return;
      this.repaintRequested = true;
      setTimeout(function(s) { s.drawAll(); }, 10, this);
    }

    function registerListeners(arr,l) {
      for(var i = 0; i < arr.length; i++) arr[i].listeners.push(l);
    }

    registerListeners(state.r, this);
    registerListeners(state.c, this);

    function getMousePos(canvas, evt) {
      var rect = canvas.getBoundingClientRect();
      return {
        x: evt.clientX - rect.left,
        y: evt.clientY - rect.top
      };
    }

    var sc = this;
    canvas.addEventListener("mousedown", function (event) {
        var mouse = getMousePos(canvas, event);
        sc.mev = {h: null, dragThr: 3, unitLen: 6};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(h.contains(mouse.x, mouse.y)) {
            if(h.onlyInvert) {
              h.arr[h.adder.index].setValue(1-h.arr[h.adder.index].getValue());
            } else {
              sc.mev.h = h;
              sc.mev.mx = mouse.x;
              sc.mev.my = mouse.y;
              sc.mev.dragging = false;
              sc.mev.startValue = h.arr[h.adder.index].getValue();
            }
            break;
          }
        }
    }, true);
    canvas.addEventListener("mousemove", function (event) {
        if(!sc.hasOwnProperty('mev') || sc.mev==null || sc.mev.h==null) return;
        var mouse = getMousePos(canvas, event);
        sc.mev.dragging = sc.mev.dragging || (Math.abs(sc.mev.mx-mouse.x)+Math.abs(sc.mev.my-mouse.y))>sc.mev.dragThr;
        if(sc.mev.dragging) {
          var ddx = (mouse.x - sc.mev.mx) / sc.mev.unitLen;
          var dx = ddx >= 0 ? Math.floor(ddx) : Math.ceil(ddx);
          var nv = sc.mev.startValue + dx;
          if(nv<0) { nv = 0; } else if(nv >= sc.mev.h.adder.base) nv = sc.mev.h.adder.base-1;
          if(sc.mev.h.arr[sc.mev.h.adder.index].getValue() != nv) {
            sc.mev.h.arr[sc.mev.h.adder.index].setValue(nv);
            //sc.mev.h.adder.calcResult();
            //sc.drawAll();
          }
        }
    }, true);
    canvas.addEventListener("mouseup", function (event) {
        if(sc.mev==null || sc.mev.h==null) return;
        var mouse = getMousePos(canvas, event);
        sc.mev.dragging = sc.mev.dragging || (Math.abs(sc.mev.mx-mouse.x)+Math.abs(sc.mev.my-mouse.y))>sc.mev.dragThr;
        if(!sc.mev.dragging) {
          var dir = event.button==0 ? 1 : -1;
          sc.mev.h.arr[sc.mev.h.adder.index].setValue((sc.mev.h.arr[sc.mev.h.adder.index].getValue()+sc.mev.h.adder.base+dir)%sc.mev.h.adder.base);
          //sc.mev.h.adder.calcResult();
          //sc.drawAll();
          sc.mev = null;
          return;
        }
        sc.mev = null;
    }, true);
}

// Prvi primjer:
var addState1 = new additionState(2);
addState1.a[0].setValue(8);
addState1.b[0].setValue(4);

var model1 = [
  new adder("myCanvas1", addState1, 0, 10, false),
  new adder("myCanvas1", addState1, 1, 10, false)
];

model1[0].offsetX = 20;
model1[1].offsetX = model1[0].offsetX+model1[0].getWidth()+20;

var sc1 = new scene("myCanvas1", model1, addState1);
sc1.drawAll();

// Drugi primjer:
var addState2 = new additionState(5);

var model2 = [
  new adder("myCanvas2", addState2, 0, 10, true),
  new adder("myCanvas2", addState2, 1, 10, true),
  new adder("myCanvas2", addState2, 2, 10, true),
  new adder("myCanvas2", addState2, 3, 10, true),
  new adder("myCanvas2", addState2, 4, 10, true)
];
model2[0].showCarryLeft = false;
model2[0].cinState = 3;
model2[1].showCarryLeft = false;
model2[2].showCarryLeft = false;
model2[3].showCarryLeft = false;

model2[4].offsetX = 20;
for(var i=3; i>=0; i--) {
 model2[i].offsetX = model2[i+1].offsetX+model2[i+1].getWidth();
}

var sc2 = new scene("myCanvas2", model2, addState2);
sc2.drawAll();


</script>

</body>

</html>
